import type { Discriminator, ServerOwnedTypes, SupportedValueTypes } from "@octopusdeploy/step-inputs";
declare type IncludeKeysByType<T, Condition> = {
    [K in keyof T]: T[K] extends Condition ? K : never;
};
declare type KeyNamesByType<T, Condition> = IncludeKeysByType<T, Condition>[keyof T];
declare type OmitByType<T, Condition> = Omit<T, KeyNamesByType<T, Condition>>;
declare type PartialByType<T, Condition> = OmitByType<T, Condition> & Partial<T>;
export declare type ObjectInitialInputs<StepInputs> = {
    [K in keyof StepInputs]: InitialInput<StepInputs[K]>;
};
export declare type InitialInputs<StepInputs> = ObjectInitialInputs<PartialByType<StepInputs, ServerOwnedTypes>>;
export declare type InitialInput<T> = T extends Discriminator<infer D> ? D : T extends SupportedValueTypes ? T : T extends Array<infer T> ? Array<InitialInput<T>> : T extends object ? InitialInputs<T> : never;
export {};
